##########################################################################
#Ɨ1v̎f[^𕪐
#
#y: xNg`̓l
#A: xNg`̐(1a܂ŁAȂŁAŎw)
#prior=F : _lBTȂ玖Oz͈̔͂wBFȂw肹B
#mL=-1000, mH=1000, sL=0, sH=100 : Oz̃p^
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
# fit:stan̏o, par:ꐔXg, prob:mxNg, 
# muA:̕, sigmaE:sd, sigmaA:sd, eta2:
# delta:ʗ, mu:S, aj;̌, Ubig:̌0ȏ,
# Usma:̌0ȉ, U2:isj傫, log_lik:ΐޓx
##########################################################################
E1Ind <- function(y,A,prior=F,mL=-1000, mH=1000, sL=0, sH=100,
prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
see=1234, cha=5, war=1000, ite=21000)
{
   library(rstan)
   if (prior) {
     dat <- list(n=length(y),a=max(A),y=y,A=A,mL=mL,mH=mH,sL=sL,sH=sH)
     scr <- "stan/E1IndPT.stan"                           # Stan t@C
   } else {
     dat <- list(n=length(y),a=max(A),y=y,A=A)
     scr <- "stan/E1IndPF.stan"                           # Stan t@C
   }
   par<-c("muA","sigmaE","sigmaA","eta2","delta",
       "mu","aj","Ubig","Usma","U2","log_lik")  # TvOϐ
   fit<-stan(file=scr,data=dat,pars=par,seed=see,chains=cha,warmup=war,iter=ite)
   ext<-extract(fit,par);muA<-ext$muA;sigmaE<-ext$sigmaE;sigmaA<-ext$sigmaA; 
   eta2<-ext$eta2;delta<-ext$delta;mu<-ext$mu;aj<-ext$aj;Ubig<-ext$Ubig;
   Usma<-ext$Usma;U2<-ext$U2;log_lik<-ext$log_lik;
   out<-list(prior=prior,fit=fit,par=par,prob=prob,muA=muA,
      sigmaE=sigmaE,sigmaA=sigmaA,eta2=eta2,delta=delta,mu=mu,aj=aj,
      Ubig=Ubig,Usma=Usma,U2=U2,log_lik=log_lik)
   class(out)<-'E1Ind'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'E1Ind'̃IuWFNg
#degits=3 : ̊ۂ
##########################################################################
print.E1Ind<-function(x,degits=3)
{
   prior<-x$prior;log_lik<-x$log_lik;
   if (prior) {print("******************Ozw******************")}
         else {print("******************OzftHg************")}
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic)
   return(invisible(out))
}  
##########################################################################
#A肪藧m(E1IndE2Indŋʂ̊֐)
#
#x:NX U2[,i,j]ij傫1łȂƂ0 邢U2A,U2B
#degits=3 : ̊ۂ
#IJ : 2̍si1ڂ͍sA2ڂ͗j
##########################################################################
printIJ<-function(x,degits=3,IJ)
{
   pro<-1
   for (i in 1:nrow(IJ)){
      pro<-pro*x[,IJ[i,1],IJ[i,2]]
   }
   print(round(mean(pro),degits))
}
##########################################################################
#Q̐̔r
#
#x:NX 'E1Ind'̃IuWFNg
#degits=3 : ̊ۂ
#I: Aϒl̑傫
#J: Aϒl̏
#cr1: 臏㗦̊l
##########################################################################
E1betw_level<-function(x,degits=3,I,J,cr1=F)
{
   G<-matrix(0,length(x$mu),5)
   G[,1] <- x$muA[,I]-x$muA[,J];
   G[,2] <- G[,1]/x$sigmaE;
   G[,3] <- pnorm(x$muA[,I],x$muA[,J],x$sigmaE);
   G[,4] <- pnorm((G[,2]/sqrt(2)), 0.0, 1.0);
   lab<-c("ϒl̍","ʗ","dx","Dz")
   co<-4
   if(is.numeric(cr1)){  co<-co+1;
      G[,5] <- pnorm(((G[,1]-cr1)/(sqrt(2)*x$sigmaE)), 0.0, 1.0);
      lab<-c(lab,paste("臏㗦(",cr1,")",sep=""));}
   Gc<-cbind(
      apply(G[,1:co],2,mean),
      apply(G[,1:co],2,sd),
      t(apply(G[,1:co],2,quantile, probs=c(0.025, 0.05, 0.5, 0.95, 0.975)))
   )
   colnames(Gc)<-c("EAP","post.sd","2.5%","5%","50%","95%","97.5%")
   rownames(Gc)<-lab
   round(Gc,degits)
}

