##########################################################################
#Ɨ2v̎f[^𕪐
#
#y: xNg`̓l
#A: xNg`̐(1a܂ŁAȂŁAŎw)
#B: xNg`̐(1b܂ŁAȂŁAŎw)
#prior=F : _lBTȂ玖Oz͈̔͂wBFȂw肹B
#mL=-1000, mH=1000, sL=0, sH=100 : Oz̃p^
#prob=c(0.025, 0.05, 0.5, 0.95, 0.975): 㕪zŕ񍐂m_
#see=1234,cha=5,war=1000,ite=21000 : MCMC֘Ãp^
#o
# fit:stan̏o, par:ꐔXg, prob:mxNg, 
#mu;S, [a]muA;A, [b]muB;B, [a,b]muAB;ݍp, 
#[a,b]cellmean;Zϒl, sigmaA;AW΍, sigmaB;BW΍,sigmaAB;ABW΍
#sigmaE;EW΍, eta2A;A, eta2B;B, eta2AB;AB, eta2T;S
#deltaA;Aʗ, deltaB;Bʗ, deltaAB;ABʗ, UbigA[a];A_l0ȏm, 
#UsmaA[a];A_l0ȉm, UbigB[b];B_l0ȏm, UsmaB[b];B_l0ȉm
#UbigAB[a,b];AB_l0ȏm, UsmaAB[a,b];AB_l0ȉm, 
#U2A[a,a];A2r, U2B[b,b];B2r, log_lik;ΐޓx
##########################################################################
E2Ind <- function(y,A,B,prior=F,mL=-1000, mH=1000, sL=0, sH=100,
prob=c(0.025, 0.05, 0.5, 0.95, 0.975),
see=1234, cha=5, war=1000, ite=21000)
{
   library(rstan)
   if (prior) {
     dat <- list(n=length(y),a=length(unique(A)),b=length(unique(B)),
                 y=y,A=A,B=B,mL=mL,mH=mH,sL=sL,sH=sH)
     scr <- "stan/E2IndPT.stan"                           # Stan t@C
   } else {
     dat <- list(n=length(y),a=length(unique(A)),b=length(unique(B)),
                 y=y,A=A,B=B)
     scr <- "stan/E2IndPF.stan"                           # Stan t@C
   }
   par<-c("mu","muA","muB","muAB","cellmean","sigmaA","sigmaB","sigmaAB",
       "sigmaE","eta2A","eta2B","eta2AB","eta2T","deltaA","deltaB","deltaAB",
       "UbigA","UsmaA","UbigB","UsmaB","UbigAB","UsmaAB","U2A","U2B","log_lik")
   fit<-stan(file=scr,data=dat,pars=par,seed=see,chains=cha,warmup=war,iter=ite)
   ext<-extract(fit,par);
   out<-list(prior=prior,fit=fit,par=par,prob=prob,
      mu=ext$mu,muA=ext$muA,muB=ext$muB,muAB=ext$muAB,cellmean=ext$cellmean,
      sigmaA=ext$sigmaA,sigmaB=ext$sigmaB,sigmaAB=ext$sigmaAB,sigmaE=ext$sigmaE,
      eta2A=ext$eta2A,eta2B=ext$eta2B,eta2AB=ext$eta2AB,eta2T=ext$eta2T,
      deltaA=ext$deltaA,deltaB=ext$deltaB,deltaAB=ext$deltaAB,UbigA=ext$UbigA,
      UsmaA=ext$UsmaA,UbigB=ext$UbigB,UsmaB=ext$UsmaB,UbigAB=ext$UbigAB,
      UsmaAB=ext$UsmaAB,U2A=ext$U2A,U2B=ext$U2B,log_lik=ext$log_lik)
   class(out)<-'E2Ind'
   return(invisible(out))
}
##########################################################################
#̃\bh
#
#x:NX 'E2Ind'̃IuWFNg
#degits=3 : ̊ۂ
##########################################################################
print.E2Ind<-function(x,degits=3)
{
   prior<-x$prior;log_lik<-x$log_lik;
   if (prior) {print("******************Ozw******************")}
         else {print("******************OzftHg************")}
   waic<- (-2)*(log(mean(exp(log_lik)))) + 2*(var(log_lik))
   print(x$fit,pars=x$par,digits_summary=degits,probs=x$prob)
   print(paste("waic=",round(waic,degits),sep=""))
   out<-list(waic=waic)
   return(invisible(out))
}  
##########################################################################
#Q̃Z̔r
#
#x:NX 'E2Ind'̃IuWFNg
#degits=3 : ̊ۂ
#H="A": Œ肷q@A or B
#F=1: AŒ肷q̐
#I=1: Arq̕ϒl̑傫
#J=2: Arq̕ϒl̏
#cr1: 臏㗦̊l
##########################################################################
E2betw_level<-function(x,degits=3,H="A",F=1,I=1,J=2,cr1=F)
{
   if (H=='A') { big<-x$cellmean[,F,I];sma<-x$cellmean[,F,J];r<-"B";}
          else { big<-x$cellmean[,I,F];sma<-x$cellmean[,J,F];r<-"A";}
   G<-matrix(0,length(x$mu),5)
   G[,1] <- big-sma;
   G[,2] <- G[,1]/x$sigmaE;
   G[,3] <- pnorm(big,sma,x$sigmaE);
   G[,4] <- pnorm((G[,2]/sqrt(2)), 0.0, 1.0);
   lab<-c("ϒl̍","ʗ","dx","Dz")
   co<-4
   if(is.numeric(cr1)){  co<-co+1;
      G[,5] <- pnorm(((G[,1]-cr1)/(sqrt(2)*x$sigmaE)), 0.0, 1.0);
      lab<-c(lab,paste("臏㗦(",cr1,")",sep=""));}
   Gc<-cbind(
      apply(G[,1:co],2,mean),
      apply(G[,1:co],2,sd),
      t(apply(G[,1:co],2,quantile, probs=c(0.025, 0.05, 0.5, 0.95, 0.975)))
   )
   colnames(Gc)<-c("EAP","post.sd","2.5%","5%","50%","95%","97.5%")
   rownames(Gc)<-lab
   cat("v",H,"̐",F,"Œ肵āAv",r,"̐",I,J,"r\n")
   round(Gc,degits)
}

